<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" %>
<%@ page import="org.apache.synapse.util.xpath.SynapseXPath" %>
<%@ page import="org.wso2.carbon.mediator.service.ui.Mediator" %>
<%@ page import="org.wso2.carbon.mediator.service.util.MediatorProperty" %>
<%@ page import="org.wso2.carbon.mediator.validate.ValidateMediator" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.ns.NameSpacesRegistrar" %>
<%@ page import="java.util.List" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<jsp:include page="../resources/resources-i18n-ajaxprocessor.jsp"/>

<%

    Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);
    if (!(mediator instanceof ValidateMediator)) {
        // todo : proper error handling
        throw new RuntimeException("Unable to edit the mediator");
    }
    ValidateMediator validateMediator = (ValidateMediator) mediator;
    // schemakeys
    List<String> keys = validateMediator.getSchemaKeys();

    // source
    SynapseXPath sourceXpth = validateMediator.getSource();
    String source = "";
    NameSpacesRegistrar namespacRegister = NameSpacesRegistrar.getInstance();
    if (sourceXpth != null) {
        namespacRegister.registerNameSpaces(sourceXpth, "mediator.validate.source", session);
        source = sourceXpth.toString();
    }

    // feature list
    List<MediatorProperty> featureList = validateMediator.getFeatures();
    String featureTableStyle = featureList.isEmpty() ? "display:none;" : "";


%>

<fmt:bundle basename="org.wso2.carbon.mediator.validate.ui.i18n.Resources">
    <carbon:jsi18n
            resourceBundle="org.wso2.carbon.mediator.validate.ui.i18n.JSResources"
            request="<%=request%>"
            i18nObjectName="validate18n"/>
    <div>
        <script type="text/javascript" src="../validate-mediator/js/mediator-util.js"></script>
        <table class="normal" width="100%">
            <tr>
                <td>
                    <h2><fmt:message key="mediator.validate.header"/></h2>
                </td>
            </tr>
            <tr>
                <td>
                    <h3 class="mediator"><fmt:message key="mediator.validate.keys"/></h3>

                    <div style="margin-top:0px;">
                        <table id="keytable" class="normal">
                            <thead>
                            <tbody id="keytbody">
                            <%
                                int i = 0;
                                if (!keys.isEmpty()) {
                                    for (String schemaKey : keys) {
                                        if (schemaKey != null) {
                            %>
                            <tr id="keyRaw<%=i%>">
                                <td>
                                    <fmt:message key="mediator.validate.key"/> <span class="required">*</span>
                                </td>
                                <td>
                                    <input class="longInput" type="text" id="key<%=i%>"
                                           name="key<%=i%>"
                                           value="<%=schemaKey%>" readonly="true"/>
                                </td>
                                <td>
                                    <a href="#registryBrowserLink"
                                       class="registry-picker-icon-link"                                       
                                       onclick="showRegistryBrowser('key<%=i%>','/_system/config')"><fmt:message
                                            key="mediator.validate.conf.regkeys"/></a>
                                    <a href="#registryBrowserLink"
                                       class="registry-picker-icon-link"
                                       onclick="showRegistryBrowser('key<%=i%>','/_system/governance')"><fmt:message
                                            key="mediator.validate.gov.regkeys"/></a>                                    
                                </td>
                                <td><a href="#" class="delete-icon-link"
                                       onclick="deleteKey(<%=i%>);return false;"><fmt:message
                                        key="mediator.validator.delete"/></a>
                                </td>
                            </tr>
                            <%
                                    }
                                    i++;
                                }
                            } else {
                            %>
                            <tr id="keyRaw<%=i%>">
                                <td>
                                    <fmt:message key="mediator.validate.key"/><span class="required">*</span>
                                </td>
                                <td>
                                    <input class="longInput" type="text" id="key<%=i%>"
                                           name="key<%=i%>"
                                           value="" readonly="true"/>
                                </td>
                                <td>
                                    <a href="#registryBrowserLink"
                                       class="registry-picker-icon-link"                                       
                                       onclick="showRegistryBrowser('key<%=i%>','/_system/config')"><fmt:message
                                            key="mediator.validate.conf.regkeys"/></a>
                                    <a href="#registryBrowserLink"
                                       class="registry-picker-icon-link"
                                       onclick="showRegistryBrowser('key<%=i%>','/_system/governance')"><fmt:message
                                            key="mediator.validate.gov.regkeys"/></a>
                                </td>
                                <td><a href="#" class="delete-icon-link"
                                       onclick="deleteKey(<%=i%>);return false;"><fmt:message
                                        key="mediator.validator.delete"/></a>
                                </td>
                            </tr>
                            <%
                                }
                            %>
                            <input type="hidden" name="keyCount" id="keyCount" value="<%=i%>"/>
                            </tbody>
                            </thead>
                        </table>
                    </div>
                </td>
            </tr>

            <tr>
                <td>
                    <div style="margin-top:0px;">
                        <a name="addSchemaNameLink"></a>
                        <a class="add-icon-link"
                           href="#addSchemaNameLinkv"
                           onclick="addKey('<fmt:message key="mediator.validator.keyemptyerror"/>')"><fmt:message
                                key="mediator.validate.addKey"/></a>
                    </div>
                </td>
            </tr>


            <tr>
                <td>
                    <table class="normal">
                        <thead>
                        <tbody>
                        <tr>
                            <td>
                                <fmt:message key="mediator.validate.source"/>
                            </td>
                            <td>
                                <input class="longInput" type="text" id="mediator.validate.source"
                                       name="mediator.validate.source"
                                       value="<%=source%>"/>
                            </td>
                            <td>
                                <a href="#nsEditorLink" class="nseditor-icon-link"
                                   style="padding-left:40px"
                                   onclick="showNameSpaceEditor('mediator.validate.source')"><fmt:message
                                        key="mediator.validate.namespace"/></a>
                            </td>
                        </tr>
                        </tbody>
                        </thead>
                    </table>
                </td>
            </tr>

            <tr>
                <td>
                    <h3 class="mediator"><fmt:message key="mediator.validator.features"/></h3>

                    <div style="margin-top:0px;">
                        <table id="featuretable" style="<%=featureTableStyle%>;" class="styledInner">
                            <thead>
                            <tr>
                                <th width="15%"><fmt:message key="mediator.validator.feature.name"/></th>
                                <th><fmt:message key="mediator.validator.action"/></th>
                            </tr>
                            <tbody id="featuretbody">
                            <%
                                int l = 0;
                                for (MediatorProperty property : featureList) {
                                    if (property != null) {
                            %>
                            <tr id="featureRaw<%=l%>">
                                <td><input type="text" name="featureName<%=l%>" id="featureName<%=l%>"
                                           value="<%=property.getName()%>"/>
                                </td>
                                <td><a href="#" href="#" class="delete-icon-link" 
                                       onclick="deletefeature('<%=l%>');return false;"><fmt:message
                                        key="mediator.validator.delete"/></a>
                                </td>
                            </tr>
                            <%
                                    }
                                    l++;
                                }
                            %>
                            <input type="hidden" name="featureCount" id="featureCount" value="<%=l%>"/>
                            </tbody>
                            </thead>
                        </table>
                    </div>
                </td>
            </tr>
            <tr>
                <td>
                    <div style="margin-top:0px;">
                        <a name="addFeatureLink"></a>
                        <a class="add-icon-link"
                           href="#addFeatureLink"
                           onclick="addfeature('<fmt:message key="mediator.validator.emptyerror"/>')">
                            <fmt:message key="mediator.validator.addfeature"/></a>
                    </div>
                </td>
            </tr>
        </table>
        <a name="nsEditorLink"></a>

        <div id="nsEditor" style="display:none;"></div>

        <a name="registryBrowserLink"></a>

        <div id="registryBrowser" style="display:none;"></div>


    </div>
</fmt:bundle>